using System.Text;
using System;

/*
 *
 * @author Victor G. Brusca, Middlemind Games
 */
namespace com.middlemind.Eds3
{
    public class Converter
    {
        public static byte[] toByte(string v)
        {
            return toByte(v, false);
        }

        public static byte[] toByte(string v, bool flag)
        {
            byte[] abyte0 = Encoding.ASCII.GetBytes(v);
            if (flag)
            {
                abyte0 = reverse_order(abyte0, abyte0.Length);
            }
            return abyte0;
        }

        public static string toString(byte[] abyte0)
        {
            return toString(abyte0, false);
        }

        public static string toString(byte[] abyte0, bool flag)
        {
            if (flag)
            {
                abyte0 = reverse_order(abyte0, abyte0.Length);
            }
            return Encoding.ASCII.GetString(abyte0);
        }

        public static byte[] toByte(int i, bool flag)
        {
            byte[] abyte0 = new byte[4];
            for (byte byte0 = 0; byte0 <= 3; byte0++)
            {
                abyte0[byte0] = (byte)(i >> (3 - byte0) * 8);
            }
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 4);
            }
            return abyte0;
        }

        public static byte[] toByte(int i)
        {
            return toByte(i, false);
        }

        public static byte[] toByte(short word0, bool flag)
        {
            byte[] abyte0 = new byte[2];
            for (byte byte0 = 0; byte0 <= 1; byte0++)
            {
                abyte0[byte0] = (byte)(word0 >> (1 - byte0) * 8);
            }
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 2);
            }
            return abyte0;
        }

        public static byte[] toByte(short word0)
        {
            return toByte(word0, false);
        }

        public static byte[] toByte(long l, bool flag)
        {
            byte[] abyte0 = new byte[8];
            for (byte byte0 = 0; byte0 <= 7; byte0++)
            {
                abyte0[byte0] = (byte)(int)(l >> (7 - byte0) * 8);
            }
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 8);
            }
            return abyte0;
        }

        public static byte[] toByte(long l)
        {
            return toByte(l, false);
        }

        public static byte[] toByte(char c, bool flag)
        {
            byte[] abyte0 = new byte[2];
            for (byte byte0 = 0; byte0 <= 1; byte0++)
            {
                abyte0[byte0] = (byte)(c >> (1 - byte0) * 8);
            }
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 2);
            }
            return abyte0;
        }

        public static byte[] toByte(char c)
        {
            return toByte(c, false);
        }

        public static byte[] toByte(float f, bool flag)
        {
            return System.BitConverter.GetBytes(f);
        }

        public static byte[] toByte(float f)
        {
            return toByte(f, false);
        }

        public static byte[] toByte(double d, bool flag)
        {
            return System.BitConverter.GetBytes(d);
        }

        public static byte[] toByte(double d)
        {
            return toByte(d, false);
        }

        public static int toInt(byte[] abyte0, bool flag)
        {
            int i = 0;
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 4);
            }
            for (byte byte0 = 0; byte0 <= 3; byte0++)
            {
                int j;
                if (abyte0[byte0] < 0)
                {
                    abyte0[byte0] = (byte)(abyte0[byte0] & 0x7f);
                    j = abyte0[byte0];
                    j |= 0x80;
                }
                else
                {
                    j = abyte0[byte0];
                }
                i |= j;
                if (byte0 < 3)
                {
                    i <<= 8;
                }
            }

            return i;
        }

        public static int toInt(byte[] abyte0)
        {
            return toInt(abyte0, false);
        }

        public static short toShort(byte[] abyte0, bool flag)
        {
            short word0 = 0;
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 2);
            }
            for (byte byte0 = 0; byte0 <= 1; byte0++)
            {
                short word1;
                if (abyte0[byte0] < 0)
                {
                    abyte0[byte0] = (byte)(abyte0[byte0] & 0x7f);
                    word1 = abyte0[byte0];
                    word1 |= 0x80;
                }
                else
                {
                    word1 = abyte0[byte0];
                }
                word0 |= word1;
                if (byte0 < 1)
                {
                    word0 <<= 8;
                }
            }

            return word0;
        }

        public static short toShort(byte[] abyte0)
        {
            return toShort(abyte0, false);
        }

        public static long toLong(byte[] abyte0, bool flag)
        {
            long l = 0L;
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 8);
            }
            for (byte byte0 = 0; byte0 <= 7; byte0++)
            {
                long l1;
                if (abyte0[byte0] < 0)
                {
                    abyte0[byte0] = (byte)(abyte0[byte0] & 0x7f);
                    l1 = abyte0[byte0];
                    l1 |= 128L;
                }
                else
                {
                    l1 = abyte0[byte0];
                }
                l |= l1;
                if (byte0 < 7)
                {
                    l <<= 8;
                }
            }

            return l;
        }

        public static long toLong(byte[] abyte0)
        {
            return toLong(abyte0, false);
        }

        public static char toChar(byte[] abyte0, bool flag)
        {
            char c = '\0';
            if (flag)
            {
                abyte0 = reverse_order(abyte0, 2);
            }
            c = (char)((c | (char)abyte0[0]) << 8);
            c |= (char)abyte0[1];
            return c;
        }

        public static char toChar(byte[] abyte0)
        {
            return toChar(abyte0, false);
        }

        public static float toFloat(byte[] abyte0, bool flag)
        {
            return (float)System.BitConverter.ToSingle(abyte0, 0);
        }

        public static float toFloat(byte[] abyte0)
        {
            return toFloat(abyte0, false);
        }

        public static double toDouble(byte[] abyte0, bool flag)
        {
            return System.BitConverter.ToDouble(abyte0, 0);
        }

        public static double toDouble(byte[] abyte0)
        {
            return toDouble(abyte0, false);
        }

        private static byte[] reverse_order(byte[] abyte0, int i)
        {
            byte[] abyte1 = new byte[i];
            for (byte byte0 = 0; byte0 <= i - 1; byte0++)
            {
                abyte1[byte0] = abyte0[i - 1 - byte0];
            }
            return abyte1;
        }

        public Converter()
        {
        }
    }
}
