﻿using System;
using System.Collections.Generic;

/*
 *
 * @author Victor G. Brusca, Middlemind Games
 */
namespace com.middlemind.Eds3.unity
{
    public interface GameObjectManager
    {
        Dictionary<int, GameObjectWrapper> GetGameObjects();
        Dictionary<int, GameObjectWrapper> GetNetworkGameObjects();
        Dictionary<int, GameObjectWrapper> GetInNetworkGameObjects();
        Dictionary<string, int> GetNameToGameObjectId();
                    
        GameObjectWrapper GetPlayerChar();
        void SetPlayerChar(GameObjectWrapper pc);

        HandleGameObjectWrapperSerialization GetSerializationHandler();
        void SetSerializationHandler(HandleGameObjectWrapperSerialization SerH);
        void RegisterGameObjectName(String name, int id);
        void AddGameObject(GameObjectWrapper obj, bool isNetwork);
        void AddInNetworkGameObject(GameObjectWrapper obj);

        byte[] SerializeNetworkGameObjects();
        byte[] SerializeGameObjects();
        void DeserializeNetworkGameObjects(byte[] bIn);
        void DeserializeGameObjects(byte[] bIn);

        bool NetworkGameObjectsEquals(GameObjectManager gom);
        bool GameObjectsEquals(GameObjectManager gom);
    }
}
