﻿using System;
using static com.middlemind.Eds3.unity.GameObjectWrapperDefault;

/*
 *
 * @author Victor G. Brusca, Middlemind Games
 */
namespace com.middlemind.Eds3.unity
{
    public interface GameObjectWrapper
    {
        GameObjectWrapperSerMode GetObjSerMode();
        void SetObjSerMode(GameObjectWrapperSerMode osm);
    
        int[] GetBinaryLengths();
        void SetBinaryLengths(int[] bl);
        int[] GetBinaryOffsets();
        void SetBinaryOffsets(int[] bo);
        int GetTotalLength();
        void SetTotalLength(int len);
    
        long GetLastSerTimeStamp();
        void SetLastSerTimeStamp(long l);        
        bool GetIsNetworkObject();
        void SetIsNetworkObject(bool isNo);
        int GetMode();
        void SetMode(int m);
        int GetPlayerId();
        void SetPlayerId(int p);

        float GetX();
        void SetX(float inX);
        float GetY();
        void SetY(float inY);
        float GetZ();
        void SetZ(float inZ);

        float GetRotX();
        void SetRotX(float inX);
        float GetRotY();
        void SetRotY(float inY);
        float GetRotZ();
        void SetRotZ(float inZ);
        float GetRotW();
        void SetRotW(float inW);

        float GetVelX();
        void SetVelX(float velX);
        float GetVelY();
        void SetVelY(float velY);
        float GetVelZ();
        void SetVelZ(float velZ);

        bool GetIsPlayerCharacter();
        void SetIsPlayerCharacter(bool ipc);
        int GetId();
        void SetId(int inId);

        int GetTypeId();
        void SetTypeId(int inTypeId);    
    
        byte[] Serialize();
        void Deserialize(byte[] dIn);
        bool Equals(GameObjectWrapper gow);
    }
}
